﻿UseSQLiteDatabase()
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()
UsePNGImageDecoder()

IncludeFile "dlgSearch.pbi"


Global SongDB.i,Popmnu.i,Searchcriteria.s

Global CurrentSound.i,CurrentTrack.i,CurrentLength.i,CurrentPos.i,PlayerStatus.i,PlayLoop.i
Global MusicFolder.s

Global PlayerMain.i,TreeMain.i, SongList.i, lstPlayList.i, txtCurrent.i,Songprogress.i,PlayerButtons.i,txtPosLen.i

Global IgStart,IgStop,IgPlay,IgNext,IgLoadPlay,IgSavePlay,IgShuffle,IgClear,IgRemove

Global ImgFirstEnabled,ImgFirstDisabled,ImgStopEnabled,ImgStopDisabled,ImgPlayEnabled,ImgPlayDisabled
Global ImgPauseEnabled,ImgPauseDisabled,ImgNextEnabled,ImgNextDisabled,ImgLoadPlaylist,ImgSavePlaylist
Global ImgShuffle,ImgClear,ImgRemove

;Load Images For Buttons
ImgFirstEnabled =CatchImage(#PB_Any, ?StartEnabled)
ImgFirstDisabled =CatchImage(#PB_Any, ?StartDisabled)
ImgStopEnabled =CatchImage(#PB_Any, ?StopEnabled)
ImgStopDisabled =CatchImage(#PB_Any, ?StopDisabled)
ImgPlayEnabled =CatchImage(#PB_Any, ?PlayEnabled)
ImgPlayDisabled =CatchImage(#PB_Any, ?PlayDisabled)
ImgNextEnabled =CatchImage(#PB_Any, ?NextEnabled)
ImgNextDisabled =CatchImage(#PB_Any, ?NextDisabled)
ImgPauseEnabled =CatchImage(#PB_Any, ?PauseEnabled)
ImgPauseDisabled =CatchImage(#PB_Any, ?PauseDisabled)
ImgLoadPlaylist =CatchImage(#PB_Any, ?LoadPlay)
ImgSavePlaylist =CatchImage(#PB_Any, ?SavePlay)
ImgShuffle =CatchImage(#PB_Any, ?ShufflePlay)
ImgClear =CatchImage(#PB_Any, ?ClearPlay)
ImgRemove =CatchImage(#PB_Any, ?RemovePlay)

Enumeration FormMenu
  #mnuSelectFile
  #mnuSelectFolder
  #mnuLoop
  #Exit
  #AddSongs
  #mnuSearch
EndEnumeration

Enumeration ;PlayerStatus
  #NotReady
  #Ready 
  #Playing 
  #Paused
  #Stopped
EndEnumeration

Structure Song
  ID.i
  Title.s
  FileName.s
EndStructure

Global Dim CurrentList.Song(0)

Popmnu = CreatePopupMenu(#PB_Any)      
MenuItem(#AddSongs, "Add To Playlist")

Macro deleteArrayElement(ar, el)
 
  For a=el To ArraySize(ar()) - 1
    ar(a) = ar(a+1)
  Next 
 
  ReDim ar(ArraySize(ar())-1)
 
EndMacro

Macro FileExists(filename)
  Bool(FileSize(fileName) > -1)
EndMacro

Procedure OpenSongsDB()
  
  SongDB = OpenDatabase(#PB_Any,"Songs.db","","")
  
EndProcedure

Procedure Load_Artist_Songs(ArtistID.i)
  
  Define Criteria.s,SongTitle.s,SongID.i,SongFileName.s,iLoop.i
  
  ;Clear SongList
  ClearGadgetItems(SongList)
  
  Criteria = "SELECT * FROM Songs WHERE Artist_ID = " + Str(ArtistID) + " ORDER BY Title COLLATE NOCASE" ;ASC"
  
  DatabaseQuery(SongDB,Criteria)
  
  While NextDatabaseRow(SongDB)
    
    SongTitle =  GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"Title"))
    SongID =  GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Song_ID"))
    SongFileName = GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"FileName"))
    
    AddGadgetItem(SongList,-1,SongTitle + Chr(10) + SongFileName)
    SetGadgetItemData(SongList,CountGadgetItems(SongList)-1, SongID)   
    
  Wend
  
  FinishDatabaseQuery(SongDB)
  
  ;Colour Alternate Rows
  For iLoop = 0 To CountGadgetItems(SongList) Step 2
  
    SetGadgetItemColor(SongList,  iLoop, #PB_Gadget_BackColor,  $FFFFCC, #PB_All)
  
  Next iLoop
  
EndProcedure

Procedure SetPlayerbuttons()

  Select PlayerStatus
      
    Case #NotReady
      DisableGadget(IgStart,#True)
      SetGadgetState(IgStart,ImageID(ImgFirstDisabled))      
      SetGadgetState(IgStop,ImageID(ImgStopDisabled))     
      SetGadgetState(IgPlay,ImageID(ImgPlayDisabled))
      SetGadgetState(IgNext,ImageID(ImgNextDisabled))      
      
    Case #Ready
      DisableGadget(IgStart,#True)
      SetGadgetState(IgStart,ImageID(ImgFirstDisabled))      
      SetGadgetState(IgStop,ImageID(ImgStopDisabled))     
      SetGadgetState(IgPlay,ImageID(ImgPlayEnabled))
      SetGadgetState(IgNext,ImageID(ImgNextDisabled)) 
      
    Case #Stopped
      DisableGadget(IgStart,#True)
      SetGadgetState(IgStart,ImageID(ImgFirstDisabled))      
      SetGadgetState(IgStop,ImageID(ImgStopDisabled))     
      SetGadgetState(IgPlay,ImageID(ImgPlayEnabled))
      SetGadgetState(IgNext,ImageID(ImgNextDisabled))
      
    Case #Playing
      DisableGadget(IgStart,#False)
      SetGadgetState(IgStart,ImageID(ImgFirstEnabled))      
      SetGadgetState(IgStop,ImageID(ImgStopEnabled))
      SetGadgetState(IgPlay,ImageID(ImgPauseEnabled))
      SetGadgetState(IgNext,ImageID(ImgNextEnabled))   
      
    Case #Paused
      DisableGadget(IgStart,#True)
      SetGadgetState(IgStart,ImageID(ImgFirstDisabled))      
      SetGadgetState(IgStop,ImageID(ImgStopDisabled))     
      SetGadgetState(IgPlay,ImageID(ImgPlayEnabled))
      SetGadgetState(IgNext,ImageID(ImgNextDisabled))        
    
    EndSelect
  
EndProcedure



Procedure PlaySong()
  
  If IsSound(CurrentSound)
    FreeSound(CurrentSound)
  EndIf

  ;Play the Currently Selected Song
  CurrentSound = LoadSound(#PB_Any, CurrentList(CurrentTrack)\FileName)
  CurrentLength = SoundLength(CurrentSound, #PB_Sound_Millisecond) 

  SetGadgetAttribute(Songprogress, #PB_ProgressBar_Maximum, Int(CurrentLength/1000)) 
  SetGadgetState(Songprogress,0)
  PlaySound(CurrentSound)
  
EndProcedure

Procedure AddArtists()

  ;Add Artists to tree view
  
  Define Criteria.s,ArtistName.s,ArtistID.i
  
  AddGadgetItem (TreeMain, -1, "Artists", 0, 0)
  
  ;Add A-Z
  For iLoop = 65 To 90

    AddGadgetItem(TreeMain, -1, Chr(iLoop), 0, 1) 
    SetGadgetItemData(TreeMain,CountGadgetItems(TreeMain)-1, -1) 
  
    Criteria = "Select Distinct * FROM Artists Where Name Like '" + Chr(iLoop) + "%' COLLATE NOCASE Order By Name COLLATE NOCASE ASC"

    DatabaseQuery(SongDB,Criteria)
  
    While NextDatabaseRow(SongDB)
    
    ArtistName = GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"Name"))
    ArtistID = GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Artist_ID"))

    
    AddGadgetItem(TreeMain, -1, ArtistName, 0, 2)
    SetGadgetItemData(TreeMain,CountGadgetItems(TreeMain)-1, ArtistID)   

  Wend  

  Next iLoop 
 
  
EndProcedure

Procedure AddFile(Filename.s)
  
    Define Artist.s,Title.s,Criteria.s
  Define ArtistID.i
  
  ;Check For Duplicate
  Criteria = "SELECT * FROM Songs WHERE Filename = '" + Filename + "';"
  DatabaseQuery(SongDB,Criteria)
  If Not FirstDatabaseRow(SongDB)
    ;Not In database So Add
    FinishDatabaseQuery(SongDB)
  
    Artist = StringField(GetFilePart(Filename,#PB_FileSystem_NoExtension),1," - ")
    Title = StringField(GetFilePart(Filename,#PB_FileSystem_NoExtension),2," - ")    

    Criteria = "SELECT * FROM Artists WHERE Name = '" + Artist + "';"
    DatabaseQuery(SongDB,Criteria)
    
    If FirstDatabaseRow(SongDB)
      ;exists allready
      ArtistID = GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Artist_ID"))
      FinishDatabaseQuery(SongDB)
      
    Else
      Artist = ReplaceString(Artist,"'","''")
      Criteria = "INSERT INTO Artists (Name) VALUES('" + Artist + "');"
      DatabaseUpdate(SongDB,Criteria)
      Criteria = "SELECT * FROM Artists WHERE Name = '" + Artist + "';"
      DatabaseQuery(SongDB,Criteria)
      FirstDatabaseRow(SongDB)
      ArtistID = GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Artist_ID"))
      FinishDatabaseQuery(SongDB)
    EndIf
    
    ;ToDo Check No Duplicate Songs    
    
    Title = ReplaceString(Title,"'","''")
    Filename = ReplaceString(Filename,"'","''")
    Criteria = "INSERT INTO Songs(Artist_ID,Title,FileName) VALUES(" + Str(ArtistID) + ",'" + Title + "','" + Filename + "');"
    DatabaseUpdate(SongDB,Criteria)
  EndIf
  FinishDatabaseQuery(SongDB)
  
EndProcedure

Procedure AddSongAZ()
  
  ;Add Songs A to Z to tree view
  
  AddGadgetItem (TreeMain, -1, "Songs", 0, 0)
  
  
  For iLoop = 65 To 90

     AddGadgetItem(TreeMain, -1, Chr(iLoop), 0, 1) 
     SetGadgetItemData(TreeMain,CountGadgetItems(TreeMain)-1, -1) 
  
   Next iLoop   
  
EndProcedure

Procedure AddsingleSong()
  
  ;Add a single File to database
  
  Define Filename.s,Artist.s,Title.s,Criteria.s
  Define ArtistID.i

  Filename = OpenFileRequester("Choose an .ogg file", "", "music files|*.ogg",0)
  If Filename
    
    AddFile(Filename)
    
    
    
 ;   Artist = StringField(GetFilePart(Filename,#PB_FileSystem_NoExtension),1," - ")
 ;   Title = StringField(GetFilePart(Filename,#PB_FileSystem_NoExtension),2," - ")    

 ;   Criteria = "SELECT * FROM Artists WHERE Name = '" + Artist + "';"
 ;   DatabaseQuery(SongDB,Criteria)
    
 ;   If FirstDatabaseRow(SongDB)
 ;     ;exists allready
 ;     ArtistID = GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Artist_ID"))
 ;     FinishDatabaseQuery(SongDB)
      
 ;   Else
      
 ;     Criteria = "INSERT INTO Artists (Name) VALUES('" + Artist + "');"
 ;     DatabaseUpdate(SongDB,Criteria)
 ;     Criteria = "SELECT * FROM Artists WHERE Name = '" + Artist + "';"
 ;     DatabaseQuery(SongDB,Criteria)
 ;     FirstDatabaseRow(SongDB)
 ;     ArtistID = GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Artist_ID"))
 ;     FinishDatabaseQuery(SongDB)
 ;   EndIf
    
    ;ToDo Check No Duplicate Songs    
    
 ;   Title = ReplaceString(Title,"'","''")
 ;   Filename = ReplaceString(Filename,"'","''")
 ;   Criteria = "INSERT INTO Songs(Artist_ID,Title,FileName) VALUES(" + Str(ArtistID) + ",'" + Title + "','" + Filename + "');"
 ;   DatabaseUpdate(SongDB,Criteria)
    
 ;   Load_Artist_Songs(ArtistID)
    
    
  EndIf
  
EndProcedure

Procedure AddFolder()
  
Define DirectoryName.s 
Define FileType.i

;Create a new LinkedList that will hold the results of our directory 'scan' 
Global NewList Listings.s() 

;Choose a directory 
DirectoryName = PathRequester("Please choose a folder...", MusicFolder) 


MusicFolder = DirectoryName

;Examine that directory 
If ExamineDirectory(1, DirectoryName, "*.ogg") ; If directory can be read... 
  Repeat 
    FileType = NextDirectoryEntry(1) 
    If FileType > 0
      AddElement(Listings()) 
      Listings() = DirectoryName + DirectoryEntryName(1) 
    EndIf          
  Until FileType = 0
EndIf 

ForEach Listings() 
  
  AddFile(Listings())

 Next 
 
 ClearGadgetItems(TreeMain)
 
  AddArtists()
     
  AddSongAZ()
 
 
 
 
EndProcedure

Procedure ShowPlayList()
  
  Define iLoop.i
  
  ClearGadgetItems(lstPlayList)
  
  For iLoop = 0 To ArraySize(CurrentList()) - 1

    AddGadgetItem(lstPlayList,-1,CurrentList(iLoop)\Title)
  
  Next iLoop
  
  SetGadgetState(lstPlayList,CurrentTrack)
  
EndProcedure

Procedure LoadSearch(Criteria.s)
  
  Define SongTitle.s,SongID.i,SongFileName.s,iLoop.i
  
  ;Clear ListIcon
  
    ClearGadgetItems(SongList)
    
   Criteria = "SELECT * FROM Songs WHERE " + Criteria + " ORDER BY Title ASC"
  
  DatabaseQuery(SongDB,Criteria)
  
  While NextDatabaseRow(SongDB)
    
    SongTitle =  GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"Title"))
    SongID =  GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Song_ID"))
    SongFileName = GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"FileName"))
    
    AddGadgetItem(SongList,-1,SongTitle + Chr(10) + SongFileName)
    SetGadgetItemData(SongList,CountGadgetItems(SongList)-1, SongID)   
    
  Wend
  
  FinishDatabaseQuery(SongDB)   
  
  For iLoop = 0 To CountGadgetItems(SongList) Step 2
  
    SetGadgetItemColor(SongList,  iLoop, #PB_Gadget_BackColor,  $FFFFCC, #PB_All)
  
  Next iLoop

EndProcedure


Procedure LoadAZSongs(Letter.s)
  
    Define Criteria.s,SongTitle.s,SongID.i,SongFileName.s,iLoop.i
  
  ;Clear ListIcon
  
    ClearGadgetItems(SongList)
    
   Criteria = "SELECT * FROM Songs WHERE Title LIKE '" + Letter + "%' ORDER BY Title ASC"
  
  DatabaseQuery(SongDB,Criteria)
  
  While NextDatabaseRow(SongDB)
    
    SongTitle =  GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"Title"))
    SongID =  GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Song_ID"))
    SongFileName = GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"FileName"))
    
    AddGadgetItem(SongList,-1,SongTitle + Chr(10) + SongFileName)
    SetGadgetItemData(SongList,CountGadgetItems(SongList)-1, SongID)   
    
  Wend
  
  FinishDatabaseQuery(SongDB)   
  
    For iLoop = 0 To CountGadgetItems(SongList) Step 2
  
  SetGadgetItemColor(SongList,  iLoop, #PB_Gadget_BackColor,  $FFFFCC, #PB_All)
  
  Next iLoop
EndProcedure



Procedure ShuffleplayList()
  
  If PlayerStatus = #Playing
    
    MessageRequester("Simple Player","playlist Functions Not Available While Playing",#PB_MessageRequester_Ok)
    
  Else
  
    RandomizeArray(CurrentList(),0,ArraySize(CurrentList()) - 1)
  
    ClearGadgetItems(lstPlayList)
  
    For iLoop = 0 To ArraySize(CurrentList()) - 1
    
      AddGadgetItem(lstPlayList,iLoop,CurrentList(iLoop)\Title)
    
    Next
  
  EndIf
 
EndProcedure

Procedure SavePlaylist()
  
  Define Criteria.s,iLoop.i,ListName.s
  
  
    ListName = InputRequester("Simple Player", "Enter Unique Playlist Title.", "")

  If ListName > ""

  
  
  ;Clear Current Playlist
  Criteria = "DELETE FROM Playlists WHERE Name = '" + ListName + "'"
  DatabaseUpdate(SongDB,Criteria)
  
  
  For iLoop = 0 To ArraySize(CurrentList()) - 1
    
    Criteria = "INSERT INTO Playlists(Name,Song_id) VALUES('" + ListName + "'," + Str(CurrentList(iLoop)\ID) + ");"
    
    DatabaseUpdate(SongDB,Criteria)
    
  Next iLoop
  
  
  EndIf
  
EndProcedure

Procedure LoadPlaylist()
  
  Define Criteria.s
  Define dlgSelPlay.i,
  Dim SongIDS.i(0)
  Define cmbPlaylist, btnOk, btnCancel,Quit,ListToLoad.s
  
  If PlayerStatus = #Playing
    
    MessageRequester("Simple Player","Load Playlist Not Available While Playing",#PB_MessageRequester_Ok)
    
  Else
    
    DisableWindow(PlayerMain,#True)
    
    dlgSelPlay = OpenWindow(#PB_Any, 0, 0, 260, 90, "Select Playlist", #PB_Window_SystemMenu | #PB_Window_WindowCentered)
    cmbPlaylist = ComboBoxGadget(#PB_Any, 10, 10, 240, 20)
    btnOk = ButtonGadget(#PB_Any, 20, 40, 90, 30, "Ok")
    btnCancel = ButtonGadget(#PB_Any, 150, 40, 90, 30, "Cancel")
    StickyWindow(dlgSelPlay, #True)
    Quit = #False
  
    Criteria = "SELECT DISTINCT Name FROM Playlists ORDER BY Name ASC"
    DatabaseQuery(SongDB,Criteria)
  
    While NextDatabaseRow(SongDB)
    
      AddGadgetItem(cmbPlaylist,-1,GetDatabaseString(SongDB,0))
      
    Wend
  
    SetGadgetState(cmbPlaylist,0)
    
    ;Programme Stays Here Till Window Closed
    Repeat
      
      Event = WaitWindowEvent()
      Select Event
          
        Case #PB_Event_CloseWindow ;Same as Cancel Button
          CloseWindow(dlgSelPlay)
          Quit = #True
          ListToLoad = ""   
          
        Case #PB_Event_Gadget
          Select EventGadget()
            Case btnOk
              ListToLoad = GetGadgetText(cmbPlaylist)
              Quit = #True
              CloseWindow(dlgSelPlay)
 
            Case  btnCancel
              CloseWindow(dlgSelPlay)
              Quit = #True
              ListToLoad = ""
          EndSelect
      EndSelect
    
    Until Quit = #True
    
    DisableWindow(PlayerMain,#False)
    
    If ListToLoad <> ""
  
      Criteria = "SELECT * FROM Playlists WHERE Name = '" + ListToLoad + "';"
      DatabaseQuery(SongDB,Criteria)
  
      iLoop = 0
      While NextDatabaseRow(SongDB)

        SongIDS(iLoop) = GetDatabaseLong(SongDB,DatabaseColumnIndex(SongDB,"Song_ID"))
        iLoop = iLoop + 1
        ReDim SongIDS(iLoop)
        
      Wend
  
      FinishDatabaseQuery(SongDB)
  
      ;Remove Last Empty Element
      ReDim SongIDS(iLoop-1)
  
      For iLoop = 0 To ArraySize(SongIDS())
    
        ReDim CurrentList(iLoop)
    
        Criteria = "SELECT * From Songs WHERE Song_ID = " + Str(SongIDS(iLoop))
        DatabaseQuery(SongDB,Criteria)
    
        While NextDatabaseRow(SongDB)

          CurrentList(iLoop)\ID = SongIDS(iLoop)     
          CurrentList(iLoop)\Title = GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"Title"))
          CurrentList(iLoop)\FileName = GetDatabaseString(SongDB,DatabaseColumnIndex(SongDB,"Filename"))     
      
        Wend
  
      Next
 
  
      ShowPlayList()
  
      Playerstatus = #ready
      SetPlayerbuttons()
  
    EndIf

  EndIf

EndProcedure

Procedure ClearPlayList()
  
  If PlayerStatus = #Playing
    
    MessageRequester("Simple Player","Clear Playlist Not Available While Playing",#PB_MessageRequester_Ok)
    
  Else
    
    Dim CurrentList(0)
    ShowPlayList()
    PlayerStatus = #NotReady
    SetPlayerbuttons()
    
  EndIf

EndProcedure

Procedure RemoveItem()
  
  Define aLoop.i,iLoop.i
  
  If PlayerStatus = #Playing
    
    MessageRequester("Simple Player","Remove Item Not Available While Playing",#PB_MessageRequester_Ok)
    
  Else
        
    For iLoop = 0 To ArraySize(CurrentList()) 
          
      If CurrentList(iLoop)\Title = GetGadgetText(lstPlayList)
        If ArraySize(CurrentList()) > 0
          deleteArrayElement(CurrentList, iLoop)
        EndIf
        Break
      EndIf
          
    Next iLoop
        
    ShowPlayList()
        
    If CountGadgetItems(lstPlayList) = 0
      PlayerStatus = #NotReady
      SetPlayerbuttons()
    EndIf
   
  EndIf

EndProcedure

Procedure NextSong()

  CurrentTrack = CurrentTrack + 1
  If CurrentTrack > ArraySize(CurrentList()) - 1
    If PlayLoop = #True
      CurrentTrack = 0
      SetGadgetState(lstPlayList,CurrentTrack)
      PlaySong()
      PlayerStatus = #Playing     
    Else
      If IsSound(CurrentSound)
        FreeSound(CurrentSound)
      EndIf
      PlayerStatus = #Stopped
      SetGadgetState(Songprogress,0)
    EndIf
  Else
    SetGadgetState(lstPlayList,CurrentTrack)
    PlaySong()
    PlayerStatus = #Playing 
  EndIf

  SetPlayerbuttons()
  
EndProcedure

Procedure.s GetParent()
  
  Define iLoop.i,ParentText.s
  
  CurrentItem.i = GetGadgetState(TreeMain)
  If GetGadgetItemAttribute(TreeMain, CurrentItem, #PB_Tree_SubLevel) > 0
    For iLoop = CurrentItem To 0 Step -1
      If GetGadgetItemAttribute(TreeMain, iLoop, #PB_Tree_SubLevel) = 0

        ParentText = GetGadgetItemText(TreeMain, iLoop) 
        Break
      EndIf
    Next
   
  Else
    
    ParentText = ""
    
  EndIf
    
    ProcedureReturn ParentText

EndProcedure

Procedure.s TrackTime(Elapsed.i)
  
  Define Mins.i
  Define secs.i
  Define trackTime.s
  
  secs = Mod(Elapsed,60000)/1000

  mins = Elapsed/60000

  
  TrackTime = "Elapsed " + Str(mins) + "m" + Str(secs) + "s Of "
  
  
  
  secs = Mod(currentLength,60000)/1000

  mins = currentLength/60000
  
  TrackTime = TrackTime + Str(mins) + "m" + Str(secs) + "s"
  
  ProcedureReturn TrackTime
  
EndProcedure

  PlayerMain = OpenWindow(#PB_Any, 10, 10, 950, 480, "Simple Music Player", #PB_Window_SystemMenu)
  CreateMenu(0, WindowID(PlayerMain))
  MenuTitle("Media")
  MenuItem(#mnuSelectFile, "Select File")
  MenuItem(#mnuSelectFolder, "Select Folder")
  MenuBar()
  MenuItem(#mnuSearch, "Search Titles")  
  MenuBar()
  MenuItem(#Exit, "Exit")

  TreeMain = TreeGadget(#PB_Any, 10, 10, 220, 430)
  SongList = ListIconGadget(#PB_Any, 240, 10, 510, 430, "Title", 150,#PB_ListIcon_CheckBoxes|#PB_ListIcon_FullRowSelect)
  AddGadgetColumn(SongList, 1, "Filename", 355)
  lstPlayList = ListViewGadget(#PB_Any, 760, 35, 180, 300)
  txtCurrent = TextGadget(#PB_Any, 760, 10, 180, 20, "Currently Playing")
  txtPosLen = TextGadget(#PB_Any, 760, 375, 180, 20, "0m0s of 0m0s")
  Songprogress = ProgressBarGadget(#PB_Any, 760, 395, 180, 10, 0, 0)
  
  SetGadgetColor(TreeMain,#PB_Gadget_BackColor,$99FFFF)
  AddWindowTimer(PlayerMain, 123, 500) ;Update Every Half Second
 
  IgStart = ImageGadget(#PB_Any, 760, 410, 32, 32, ImageID(ImgFirstDisabled))
  IgStop = ImageGadget(#PB_Any, 792, 410, 32, 32, ImageID(ImgStopDisabled))
  IgPlay = ImageGadget(#PB_Any, 824, 410, 32, 32, ImageID(ImgPlayDisabled))
  IgNext = ImageGadget(#PB_Any, 856, 410, 32, 32, ImageID(ImgNextDisabled))
  GadgetToolTip(IgStart, "Goto Start")
  GadgetToolTip(IgStop, "Stop All")  
  GadgetToolTip(IgPlay, "Play/Pause")  
  GadgetToolTip(IgNext, "Next Song")
  
  IgLoadPlay = ImageGadget(#PB_Any, 760, 340, 32, 32, ImageID(ImgLoadPlaylist))
  IgSavePlay = ImageGadget(#PB_Any, 792, 340, 32, 32, ImageID(ImgSavePlaylist))
  IgShuffle = ImageGadget(#PB_Any, 824, 340, 32, 32, ImageID(ImgShuffle))
  IgClear = ImageGadget(#PB_Any, 856, 340, 32, 32, ImageID(ImgClear))
  IgRemove = ImageGadget(#PB_Any, 888, 340, 32, 32, ImageID(ImgRemove))
  GadgetToolTip(IgSavePlay, "Save Playlist")
  GadgetToolTip(IgLoadPlay, "Load Playlist")  
  GadgetToolTip(IgShuffle, "Shuffle")
  GadgetToolTip(IgClear, "Clear Playlist")  
  GadgetToolTip(IgRemove, "Remove Item") 
  
  PlayerStatus = #NotReady
  SetPlayerbuttons()

  ;Open Database First    
  OpenSongsDB()    
     
  AddArtists()
     
  AddSongAZ()
 
  PlayLoop = #False  ;Do Not Play In Loop Mode
  
  If OpenPreferences("Simple Player.prefs")
    PreferenceGroup("Global")
    MusicFolder = ReadPreferenceString("MusicFolder","Nice Try")
    ClosePreferences()
    
  Else

    CreatePreferences("Simple Player.prefs")
    PreferenceGroup("Global")
    WritePreferenceString("MusicFolder", "")
    ClosePreferences()
    MusicFolder = "" 
    
  EndIf

  Repeat
      
    Event = WaitWindowEvent(10)
  
    Select Event
        
      Case #PB_Event_CloseWindow
 
        If OpenPreferences("Simple Player.prefs")
          PreferenceGroup("Global")
          WritePreferenceString("MusicFolder", MusicFolder)
          ClosePreferences()
          
        EndIf
        
        End
  
      Case #PB_Event_Timer
        
        If IsSound(CurrentSound)
          CurrentPos = GetSoundPosition(CurrentSound,#PB_Sound_Millisecond)
          SetGadgetState(Songprogress,CurrentPos/1000)
          SetGadgetText(txtPosLen,TrackTime(CurrentPos))          
          
        EndIf
        
        If PlayerStatus = #Playing
          If IsSound(CurrentSound)
            If SoundStatus(CurrentSound) = #PB_Sound_Stopped
              NextSong()
            EndIf
          EndIf
        EndIf
        
    Case #PB_Event_Menu
      Select EventMenu()
  
        Case #AddSongs ;From popup
          
          ;Add To Playlist
          For iLoop=0 To CountGadgetItems(SongList)-1
            If GetGadgetItemState(SongList, iLoop) & #PB_ListIcon_Checked
              CurrentList(ArraySize(CurrentList()))\Title = GetGadgetItemText(Songlist,iLoop,0)
              CurrentList(ArraySize(CurrentList()))\ID = GetGadgetItemData(Songlist,iLoop)
              CurrentList(ArraySize(CurrentList()))\FileName = GetGadgetItemText(Songlist,iLoop,1)
              ReDim CurrentList(ArraySize(CurrentList()) + 1)
            EndIf
          Next
          ShowPlayList()
                
          If Playerstatus = #NotReady
            If CountGadgetItems(lstPlayList) > 0
              Playerstatus = #Ready
              SetPlayerbuttons() 
            EndIf
          EndIf
          
        Case #mnuSelectFile
            
          AddsingleSong()
        
        Case #mnuSelectFolder
          
          AddFolder()
          
        Case #mnuSearch
          
          Searchcriteria = SearchMusic::Open()
          If Len(Searchcriteria) > 0
            LoadSearch(Searchcriteria)
          EndIf
          
          
        Case #Exit
          
          If OpenPreferences("Simple Player.prefs")
            
            PreferenceGroup("Global")
            WritePreferenceString("MusicFolder", MusicFolder)
            ClosePreferences()
            
          EndIf          
          
          End
            
      EndSelect
  
    Case #PB_Event_Gadget
        
      Select EventGadget()
            
        Case TreeMain
            
          If EventType() = #PB_EventType_Change
            
            Select getParent()
                
              Case ""
                
                ;Do Nothing
                
              Case "Artists"

                Load_Artist_Songs(GetGadgetItemData(TreeMain,GetGadgetState(TreeMain)))
                
              Case "Songs"

                LoadAZSongs(GetGadgetText(TreeMain))       
                
            EndSelect
            
           EndIf 

        Case SongList
            
          Select EventType()
              
            Case #PB_EventType_RightClick     
              
              DisplayPopupMenu(Popmnu, WindowID(PlayerMain))
   
          EndSelect

        Case lstPlayList
              
          If EventType() = #PB_EventType_LeftDoubleClick
                
            CurrentTrack =  GetGadgetState(lstPlayList)
            PlaySong()
            PlayerStatus = #Playing
            SetPlayerbuttons()
                
          EndIf
  
        Case IgStart  
            
          SetSoundPosition(CurrentSound,1,#PB_Sound_Millisecond)          
           
        Case IgStop  

          PlayerStatus = #Stopped
          If IsSound(CurrentSound)
            StopSound(CurrentSound)
            FreeSound(CurrentSound)
          EndIf
          SetGadgetState(Songprogress,0) 
          SetPlayerbuttons()
            
        Case IgPlay
                      
          Select PlayerStatus
                          
            Case #Ready 
                          
              If GetGadgetState(lstPlayList) > -1
                CurrentTrack = GetGadgetState(lstPlayList)
              Else
                CurrentTrack = 0
              EndIf
              SetGadgetState(lstPlayList,CurrentTrack)
              PlaySong()
              PlayerStatus = #Playing
                          
            Case #Playing
                          
              PauseSound(CurrentSound)
              PlayerStatus = #Paused
                          
            Case #Paused

              ResumeSound(CurrentSound)
              PlayerStatus = #Playing                        
                          
            Case #Stopped
              
              If GetGadgetState(lstPlayList) > -1
                CurrentTrack = GetGadgetState(lstPlayList)
              Else
                CurrentTrack = 0
              EndIf
              SetGadgetState(lstPlayList,CurrentTrack)
              PlaySong()
              PlayerStatus = #Playing                       
                          
          EndSelect
          SetPlayerbuttons()           
            
                      
        Case IgNext
                     
          NextSong()
                      
        Case IgSavePlay
                      
          SavePlaylist()
                      
        Case IgLoadPlay
                      
          LoadPlaylist()
          
        Case IgShuffle
                      
          ShuffleplayList()
          
        Case IgClear
          
          ClearPlayList()
          
        Case IgRemove
          
          RemoveItem()
          
      EndSelect
          
    EndSelect
    
  ForEver
  
  DataSection
    StartEnabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_start_blue.png"
    StartDisabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_start.png"      
    StopEnabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_stop_blue.png"
    StopDisabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_stop.png"     
    PlayEnabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_play_blue.png"
    PlayDisabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_play.png"     
    NextEnabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_end_blue.png"
    NextDisabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_end.png"    
    PauseEnabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_pause_blue.png"
    PauseDisabled:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\control_pause.png"       
    LoadPlay:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\page_white_get.png"      
    SavePlay:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\page_white_put.png"      
    ShufflePlay:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\arrow_switch.png"      
    ClearPlay:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\page_white.png"      
    RemovePlay:
      IncludeBinary "C:\PB Projects\CDs Media Player\Resources\delete_32.png"      
  EndDataSection  
    
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 177
; FirstLine = 121
; Folding = yADw
; EnableXP
; CompileSourceDirectory